# swagger_client.JobDetailsApi

All URIs are relative to *https://service.fax-api.de/4.0/rest*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_job**](JobDetailsApi.md#get_job) | **GET** /jobs/{id} | /jobs/{id}
[**get_job_notifications**](JobDetailsApi.md#get_job_notifications) | **GET** /jobs/{id}/notifications | /jobs/{id}/notifications
[**get_job_previews**](JobDetailsApi.md#get_job_previews) | **GET** /jobs/{id}/preview | /jobs/{id}/preview
[**get_job_recipients**](JobDetailsApi.md#get_job_recipients) | **GET** /jobs/{id}/recipients | /jobs/{id}/recipients
[**get_job_templates**](JobDetailsApi.md#get_job_templates) | **GET** /jobs/{id}/templates | /jobs/{id}/templates
[**put_job**](JobDetailsApi.md#put_job) | **PUT** /jobs/{id} | /jobs/{id}

# **get_job**
> Job get_job(id)

/jobs/{id}

Description: Obtain information of a specific job

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: ApiAuthKey
configuration = swagger_client.Configuration()
configuration.api_key['X-Auth-Token'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Auth-Token'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.JobDetailsApi(swagger_client.ApiClient(configuration))
id = 'id_example' # str | Identification number (UUID) of the job

try:
    # /jobs/{id}
    api_response = api_instance.get_job(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling JobDetailsApi->get_job: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**| Identification number (UUID) of the job | 

### Return type

[**Job**](Job.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_job_notifications**
> Notifications get_job_notifications(id)

/jobs/{id}/notifications

Description: To obtain a list of notifications to a specific job

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: ApiAuthKey
configuration = swagger_client.Configuration()
configuration.api_key['X-Auth-Token'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Auth-Token'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.JobDetailsApi(swagger_client.ApiClient(configuration))
id = 'id_example' # str | Identification number (UUID) of the job

try:
    # /jobs/{id}/notifications
    api_response = api_instance.get_job_notifications(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling JobDetailsApi->get_job_notifications: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**| Identification number (UUID) of the job | 

### Return type

[**Notifications**](Notifications.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_job_previews**
> Preview get_job_previews(id)

/jobs/{id}/preview

Description: To obtain the preview pdf document of a specific job

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: ApiAuthKey
configuration = swagger_client.Configuration()
configuration.api_key['X-Auth-Token'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Auth-Token'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.JobDetailsApi(swagger_client.ApiClient(configuration))
id = 'id_example' # str | Identification number (UUID) of the job

try:
    # /jobs/{id}/preview
    api_response = api_instance.get_job_previews(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling JobDetailsApi->get_job_previews: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**| Identification number (UUID) of the job | 

### Return type

[**Preview**](Preview.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_job_recipients**
> JobRecipients get_job_recipients(id, object_limit=object_limit, object_offset=object_offset, filter_fax_number=filter_fax_number, filter_fax_number_norm=filter_fax_number_norm, filter_recipient_reference=filter_recipient_reference, filter_international_dialing_code=filter_international_dialing_code, filter_result_code=filter_result_code, filter_result_text=filter_result_text, sort_field=sort_field, sort_order=sort_order)

/jobs/{id}/recipients

Description: Resource to obtain a list of recipients to a specific job

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: ApiAuthKey
configuration = swagger_client.Configuration()
configuration.api_key['X-Auth-Token'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Auth-Token'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.JobDetailsApi(swagger_client.ApiClient(configuration))
id = 'id_example' # str | Identification number (UUID) of the job
object_limit = 100 # int | Query parameter to change de default limitation of objects in the result data array (optional) (default to 100)
object_offset = 0 # int | Query parameter to change de default offset of objects in the result data array (optional) (default to 0)
filter_fax_number = 'filter_fax_number_example' # str | Query parameter to fetch recipients after his fax number (optional)
filter_fax_number_norm = 'filter_fax_number_norm_example' # str | Query parameter to fetch recipients after his normed fax number (optional)
filter_recipient_reference = 'filter_recipient_reference_example' # str | Query parameter to fetch recipients after his recipient reference (optional)
filter_international_dialing_code = 'filter_international_dialing_code_example' # str | Query parameter to fetch recipients after his international dialing code (optional)
filter_result_code = 'filter_result_code_example' # str | Query parameter to fetch recipients after his result code (optional)
filter_result_text = 'filter_result_text_example' # str | Query parameter to fetch recipients after his result text (optional)
sort_field = 'sort_field_example' # str | Available sort options for the result data array. (optional)
sort_order = 'asc' # str | Describes the order for used sort fields (optional) (default to asc)

try:
    # /jobs/{id}/recipients
    api_response = api_instance.get_job_recipients(id, object_limit=object_limit, object_offset=object_offset, filter_fax_number=filter_fax_number, filter_fax_number_norm=filter_fax_number_norm, filter_recipient_reference=filter_recipient_reference, filter_international_dialing_code=filter_international_dialing_code, filter_result_code=filter_result_code, filter_result_text=filter_result_text, sort_field=sort_field, sort_order=sort_order)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling JobDetailsApi->get_job_recipients: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**| Identification number (UUID) of the job | 
 **object_limit** | **int**| Query parameter to change de default limitation of objects in the result data array | [optional] [default to 100]
 **object_offset** | **int**| Query parameter to change de default offset of objects in the result data array | [optional] [default to 0]
 **filter_fax_number** | **str**| Query parameter to fetch recipients after his fax number | [optional] 
 **filter_fax_number_norm** | **str**| Query parameter to fetch recipients after his normed fax number | [optional] 
 **filter_recipient_reference** | **str**| Query parameter to fetch recipients after his recipient reference | [optional] 
 **filter_international_dialing_code** | **str**| Query parameter to fetch recipients after his international dialing code | [optional] 
 **filter_result_code** | **str**| Query parameter to fetch recipients after his result code | [optional] 
 **filter_result_text** | **str**| Query parameter to fetch recipients after his result text | [optional] 
 **sort_field** | **str**| Available sort options for the result data array. | [optional] 
 **sort_order** | **str**| Describes the order for used sort fields | [optional] [default to asc]

### Return type

[**JobRecipients**](JobRecipients.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_job_templates**
> Templates get_job_templates(id)

/jobs/{id}/templates

Description: To obtain a list of template documents to a specific job

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: ApiAuthKey
configuration = swagger_client.Configuration()
configuration.api_key['X-Auth-Token'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Auth-Token'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.JobDetailsApi(swagger_client.ApiClient(configuration))
id = 'id_example' # str | Identification number (UUID) of the job

try:
    # /jobs/{id}/templates
    api_response = api_instance.get_job_templates(id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling JobDetailsApi->get_job_templates: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**| Identification number (UUID) of the job | 

### Return type

[**Templates**](Templates.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **put_job**
> Job put_job(body, id)

/jobs/{id}

Description: Control the transmission of the specific job

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: ApiAuthKey
configuration = swagger_client.Configuration()
configuration.api_key['X-Auth-Token'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-Auth-Token'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.JobDetailsApi(swagger_client.ApiClient(configuration))
body = swagger_client.JobsIdBody() # JobsIdBody | Describes the required request body to perform an action on the fax job
id = 'id_example' # str | Identification number (UUID) of the job

try:
    # /jobs/{id}
    api_response = api_instance.put_job(body, id)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling JobDetailsApi->put_job: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**JobsIdBody**](JobsIdBody.md)| Describes the required request body to perform an action on the fax job | 
 **id** | **str**| Identification number (UUID) of the job | 

### Return type

[**Job**](Job.md)

### Authorization

[ApiAuthKey](../README.md#ApiAuthKey)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

